<?php
/**
*
* @package phpBB3
* @version $Id:$
* @copyright (c) 2008 Culprit & (c) 2011 Mahoney
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
/**
* @ignore
*/
if ( !defined( 'IN_PHPBB'))
{
	exit;
}


$forum_id_field = '{initial_field}';
$sql_main = "SELECT  t.topic_id, t.forum_id, t.topic_time, t.topic_replies, t.topic_views, t.topic_last_post_time, t.topic_title, MAX(p.post_id) AS last_post
					FROM " . POSTS_TABLE . " AS p, " . TOPICS_TABLE . " AS t
					WHERE {available_forums_in_set}
						AND p.topic_id = t.topic_id AND p.forum_id = t.forum_id
					GROUP BY p.topic_id";
$sql_tt_avails = array(
	'sql_topics'	=> array(
		'sql'	=>	"{$sql_main}
					ORDER BY t.topic_time DESC",
		'field'	=>	't.forum_id',
		),
	'sql_replies'	=> array(
		'sql'	=>	"{$sql_main}
					ORDER BY t.topic_replies DESC, t.topic_time DESC",
		'field'	=>	't.forum_id',
		),
	'sql_views'		=> array(
		'sql'	=>	"{$sql_main}
					ORDER BY t.topic_views DESC, t.topic_time DESC",
		'field'	=>	't.forum_id',
		),
	'sql_posts'		=> array(
		'sql'	=>	"{$sql_main}
					ORDER BY t.topic_last_post_time DESC",
		'field'	=>	't.forum_id',
		),
);

$goto_ary = array(
	0 => 'first',
	1 => 'unread',
	2 => 'last' 
);

if ( defined( 'IN_ADMIN'))
{
	return;
}


$top_topics_count = (int) $config['tt_count'];
$tt_logged = (( isset( $config['tt_logged']) && $config['tt_logged'] == 1 && $user->data['is_registered'] == 1)||$config['tt_logged']==0) ? true: false;

$visible_users_forums = $auth->acl_getf('f_read_top_content', true);
$available_forums_in_set = $db->sql_in_set( $forum_id_field, array_keys( $visible_users_forums), false, true);

$user->add_lang( 'mods/top_topics');

$rowset_order = array();
if ( $cache->_exists( '_top_topics'))
{
	$rowset_order = $cache->get( '_top_topics');
}

if ( count( $rowset_order) == 0 )
{
	$sql = "SELECT * FROM " . TT_ORDER_TABLE . " WHERE tt_display = 1 ORDER BY tt_order ASC"; 
	$rs_order = $db->sql_query( $sql);
	$rowset_order = $db->sql_fetchrowset( $rs_order);
	$db->sql_freeresult( $rs_order);
	$cache->put( '_top_topics', $rowset_order);
}

$rowset_order_count = count( $rowset_order);
$style_width = ceil( 100/$rowset_order_count) . '%';

$template->assign_vars( array(
		'TT_ALIGMENT'		=> ( isset( $config['tt_aligment']))? $config['tt_aligment'] : 'top',
		'S_TT_LOGGED_USERS' => $tt_logged,
		'TT_WIDTH'			=> ( isset($config['tt_width']) && $config['tt_width'] != '' ) ? $config['tt_width'] . "px" : '',

		'STYLE_WIDTH'	=> $style_width,
		'STYLE_WIDTH_LAST'	=> (99 - ( ($rowset_order_count -1) * $style_width )) . '%',
		));
$max_rows = 0;
for( $i_order = 0; $i_order < $rowset_order_count; $i_order++)
{
	$row_order = $rowset_order[$i_order];
	$sql = str_replace( '{available_forums_in_set}', $available_forums_in_set, $sql_tt_avails[$row_order['tt_sql']]['sql']);
	$sql = str_replace( $forum_id_field, $sql_tt_avails[$row_order['tt_sql']]['field'], $sql);
	//print $sql . ' <br />';
	$rs = $db->sql_query_limit( $sql, $top_topics_count);
	$rowset_order[$i_order]['rowset'] = $db->sql_fetchrowset( $rs);
	$rowset_order[$i_order]['count'] = count( $rowset_order[$i_order]['rowset']);

	$max_rows = ( $max_rows < $rowset_order[$i_order]['count'])? $rowset_order[$i_order]['count'] : $max_rows;
	
}
for( $i_order = 0; $i_order < $rowset_order_count; $i_order++)
{
	$title = isset( $user->lang[$rowset_order[$i_order]['tt_title']]) ? $user->lang[$rowset_order[$i_order]['tt_title']]: "{ " . $rowset_order[$i_order]['tt_title'] . " }";
	$tt_additional = $rowset_order[$i_order]['tt_additional'];
	$counter =0;

	$template->assign_block_vars( 'category', array(
		'S_FIRST'	=> ( $i_order == 0 ) ? true: false,
		'S_LAST'	=> ( $i_order == $rowset_order_count -1 ) ? true: false,

		'L_TITLE' => $title,
		));
	
	switch( $rowset_order[$i_order]['tt_goto'])
	{
		case 0:
			$add_link = '';
			break;
		case 1:
			$add_link = '&amp;view=unread#unread';
			break;
		case 2:
			$add_link = '&amp;p={last_post}#p{last_post}';
			break;
	}
	
	for( $i = 0; $i < $max_rows; $i++)
	{
		$row = $rowset_order[$i_order]['rowset'][$i];
		
		$template->assign_block_vars( 'category.row', array(
			'TITLE'			=> $row['topic_title'] == '' ? '&nbsp;' : $row['topic_title'],
			'U_LINK'		=> append_sid( 'viewtopic.' . $phpEx, 'f=' . $row['forum_id'] . '&amp;t=' . $row['topic_id'] . str_replace( '{last_post}', $row['last_post'], $add_link)),
			'ADDITIONAL'	=> ($tt_additional != '' ) ? $row[$tt_additional]: '',
			'BG_ROW' => ( ($counter++) %2 == 0) ? 'bg1' : 'bg2',
			));
	}
}
?>